#include <bits/stdc++.h>
using namespace std;
using graf=vector<vector<int>>;
int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    cin>>n>>m;
    graf g(n);
    for(int i=0; i<m ;i++)
    {
        int v, u;
        cin>>v>>u;
        g[v--].push_back(u--);
    }
    cout<<"NO";
}
